package com.eactive.eai.batch.job.jobItem.fiusc;

import java.io.ByteArrayOutputStream;

import com.eactive.eai.batch.common.CommonKeys;
import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.batch.common.StringUtil;
import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;
import com.eactive.eai.batch.scheduler.SchedulerMessageManager;
import com.eactive.eai.batch.scheduler.SchedulerMessageVO;
import com.eactive.eai.common.exception.ExceptionUtil;

public class RECV_FIUSC_0315 extends DefaultTelegram implements TelegramService
{
    /**
     * 생성자
     */
    public RECV_FIUSC_0315() {
        //파일 종료 응답
    }

    /**
     * 전문 해체하기
     */
    public boolean doExecute() {
        if (!super.doExecute()) return false;

        return true;
    }

    /**
     * 전문 Validation
     */
    public boolean doValidation()
    {
        if (!super.doValidation()) return false;
        return true;
    }

    /**
     * 이전문처리에서는 doPostExecute에서 열어놓았던 파일을 닫아준다.
     */
    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
			//DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<10; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=10; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            // 수신 파일 End DB로그
            LogUtil.setLogFileEnd(batchDoc);

            // 다음 파일거래를 위해 배치메시지 초기화
            batchDoc.getBatchMsg().getBody().setBlockNum(0);
            batchDoc.getBatchMsg().getBody().setSeqNum(0);
            batchDoc.getBatchMsg().getBody().setCurFileSize(0L);
         
            // 작업대기 큐에 다음 거래파일이 없으면 업무종료
            if ( checkMoreFile() ) {
            	this.setConditionTxt("");
            } else {
            	this.setConditionTxt(TelegramKeys.NOFILE);
            }
            
            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(ex.getMessage(),ex);
            return false;
        }
    }

    private boolean checkMoreFile(){
    	String processCode = batchDoc.getBatchMsg().getHeader().getProcessCode(); 
    	String institutionCode = batchDoc.getBatchMsg().getHeader().getInstitutionCode();
    	SchedulerMessageVO info;
    	try{
    		info = SchedulerMessageManager.getInstance().getSendJobFromQueue(processCode, institutionCode );
    		if ( info == null ) {
    			return false;
    		}
			String strUUID = batchDoc.getBatchMsg().getHeader().getUUID();
			String strSubUUID = batchDoc.getBatchMsg().getBody().getSubUUID();

			//해당 작업을 Job_Queue 테이블에서 Job_Processing 테이블로 이동
    		SchedulerMessageManager.getInstance().moveJobQueueToHandleWithNewID(info, strUUID, strSubUUID);

    		//BatchMsgDoc 값 설정
    		batchDoc.getBatchMsg().getHeader().setScheduleCode(info.getScheduleCode());
    		batchDoc.getBatchMsg().getHeader().setScheduleSTime(info.getStartTime());
    		batchDoc.getBatchMsg().getHeader().setScheduleETime(info.getEndTime());
    		batchDoc.getBatchMsg().getHeader().setFilePath(info.getFilePath());
    		batchDoc.getBatchMsg().getHeader().setFileName(info.getFileName());
    		batchDoc.getBatchMsg().getHeader().setRenamedFileName(info.getRenamedFileName());
    		batchDoc.getBatchMsg().getHeader().setJobCode(info.getJobCode());
    		batchDoc.getBatchMsg().getHeader().setBizCode(info.getBizCode());
    		batchDoc.getBatchMsg().getHeader().setFlowCode(info.getFlowRuleCode());
    		batchDoc.getBatchMsg().getHeader().setRuleCode(info.getFlowRuleCode());
    		batchDoc.getBatchMsg().getHeader().setBlockSize(info.getBlockSize());
    		batchDoc.getBatchMsg().getHeader().setSequenceSize(info.getSequenceSize());
    		batchDoc.getBatchMsg().getHeader().setPacketSize(info.getPacketSize());
    		// info에는 userId에 대한 정보가 없다. 기존의 값을 그래도 사용한다.
//    		batchDoc.getBatchMsg().getHeader().setUserID(info.getRemoteUserID());
    		batchDoc.getBatchMsg().getHeader().setUserPassword(info.getRemoteUserPW());

            // 다음 파일의 체크 파일 가져오기
            if ( info.getProcessType().equals(CommonKeys.PROCESS_REQUEST_SEND) ||
            		info.getProcessType().equals(CommonKeys.PROCESS_RESPONSE_SEND ) ){
                String hdrInfoName = info.getHdrInfoName();
                batchDoc.getBatchMsg().getHeader().setHdrInfoName(hdrInfoName);
                batchDoc.getBatchMsg().getHeader().setTotRecCnt(StringUtil.getTotRecCountFromHeader(hdrInfoName));
                batchDoc.getBatchMsg().getHeader().setBaseDate(StringUtil.getBaseDateFromHeader(hdrInfoName));
                batchDoc.getBatchMsg().getHeader().setFileSize(batchDoc.getBatchMsg().getHeader().getRecLen() * batchDoc.getBatchMsg().getHeader().getTotRecCnt());
            }
    	} catch ( Exception e){
    		return false;

    	}
    	return true;
    }
    
    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
    	String telegramNo = super.getFieldValueString(5);
    	if ( telegramNo.length() < 8 ) return "";
		return telegramNo.substring(0,3) + telegramNo.substring(6,7);
    }

    //응답코드 필드값 리턴
    public String getResCode()
    {
		return super.getFieldValueString(9);
    }

}
